/**Rx
 **
 ** RX_Refs.rexx (C) by 1992 H.P.G (support script for ReadRefs)
 **
 ** english:
 ** Rexx example to lauch ReadRefs and writes the result to a new
 ** opening CON: window
 **
 ** deutsch:
 ** Rexx Beispiele, da ReadRefs startet und das Resultat in ein
 ** neuen sich ffnendes CON-Fenster schriebt
 **
 **/

HelpString='Rx RX_Refs.rexx RefsFile Template'
CON='CON:0/0/1000/100/ReadRefs_Output/Wait/Close/Alt0/0/150/45'
Template=''  /* e.: PreInitialization  */
RefsFile=''  /* d.: Vorinitialisierung */

Parse Arg RefsFile Template

If Template=='' | RefsFile=='' Then Do
                                /* e.: There has been no Template specified */
    Call OpenCon()              /* d.: Es wurde kein Suchbegriff bergeben  */
    Call Write (out,HelpString) /* e.: Printing out a help message          */
                                /* d.: Ausgabe eines HilfsTextes            */
    Call CloseCon()
    return(5)
End
Else Do
    Address Command 'ReadRefs' RefsFile Template
                                /* e.: Launching ReadRefs with arguments    */
                                /* d.: Starten von readRefs mit Argumentetn */
    if (~Exists('t:Refs.dat')) Then Do

        say 'Template '|| Template || ' not found in ' || RefsFile

                                /* e.: Template not found                   */
    End                         /* d.: Begriff wurde nicht gefunden         */

    Else Do                     /* e.: All ok check if exists t:Refs.dat    */
                                /*     If true then prints out its contents */
                                /* d.: Alles OK Nun vergewissern, ob        */
                                /*     t:Refs.dat existiert, wenn ja, dann  */
                                /*     Ausgabe ins Cli-Fenster              */
        if (~Open(file,'t:Refs.dat','r')) Then Return(5)
        Call OpenCon()
        Do While (EOF(file) == 0)
            str=ReadLn(file)
            if (str~=='') Then Do
                Call Writeln(out,str)
            End
        End
        Call CloseCon()
    End

End

Return 0


OpenCon: Procedure Expose out CON

If (~Open(out,CON,'w+')) Then out=STDOUT

Return

CloseCon: Procedure Expose out CON

Call Close(out)

Return


