PROJ = WFILE
PROJFILE = WFILE.MAK
DEBUG = 0

PWBRMAKE  = pwbrmake
NMAKEBSC1  = set
NMAKEBSC2  = nmake
BRFLAGS  =  /o $(PROJ).bsc
BROWSE	= 1
CFLAGS_G  = /AL /G2 /DOS2 /BATCH /J
CC  = cl
CFLAGS_D  = /qc /Gi$(PROJ).mdt /Zr /Zi /Od
CFLAGS_R  = /Ot
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  =  /NOI /STACK:4096  /BATCH
LFLAGS_D  =  /CO /FAR /PACKC
LFLAGS_R  = /EXE /FAR /PACKC /PACKD /PMTYPE:VIO
LINKER	= link
ILINK  = ilink
LRF  = echo > NUL
RUNFLAGS  = history -l
CVFLAGS  =  /50

OBJS  = WFILE.obj WHELP.obj TEMPLATE.obj SCAN.obj PROFILE.obj REV.obj
SBRS  = WFILE.sbr WHELP.sbr TEMPLATE.sbr SCAN.sbr PROFILE.sbr REV.sbr

all: $(PROJ).exe

.SUFFIXES:
.SUFFIXES: .sbr .obj .c

WFILE.obj : WFILE.C wfile.h

WFILE.sbr : WFILE.C wfile.h

WHELP.obj : WHELP.C wfile.h

WHELP.sbr : WHELP.C wfile.h

TEMPLATE.obj : TEMPLATE.C

TEMPLATE.sbr : TEMPLATE.C

SCAN.obj : SCAN.C wfile.h

SCAN.sbr : SCAN.C wfile.h

PROFILE.obj : PROFILE.C

PROFILE.sbr : PROFILE.C

REV.obj : REV.C

REV.sbr : REV.C


$(PROJ).bsc : $(SBRS)
	$(PWBRMAKE) @<<
$(BRFLAGS) $(SBRS)
<<

$(PROJ).exe : $(OBJS)
!IF $(DEBUG)
	$(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
	$(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
) +
$(LIBS: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
!IF $(DEBUG)
	$(LINKER) @$(PROJ).lrf
!ELSE
	$(LINKER) @$(PROJ).lrf
!ENDIF
	$(NMAKEBSC1) MAKEFLAGS=
	$(NMAKEBSC2) $(NMFLAGS) -f $(PROJFILE) $(PROJ).bsc


.c.sbr :
!IF $(DEBUG)
	$(CC) /Zs $(CFLAGS_G) $(CFLAGS_D) /FR$@ $<
!ELSE
	$(CC) /Zs $(CFLAGS_G) $(CFLAGS_R) /FR$@ $<
!ENDIF

.c.obj :
!IF $(DEBUG)
	$(CC) /c $(CFLAGS_G) $(CFLAGS_D) /Fo$@ $<
!ELSE
	$(CC) /c $(CFLAGS_G) $(CFLAGS_R) /Fo$@ $<
!ENDIF


run: $(PROJ).exe
	$(PROJ).exe $(RUNFLAGS)

debug: $(PROJ).exe
	CVP $(CVFLAGS) $(PROJ).exe $(RUNFLAGS)
