/********************************************/
/* Edit a SOURCE or NOTE file from Origins */
/********************************************/

/* NOTE: 
   This file is the same as EditGen.rexx, except it is written for those
   situations where your editor of choice doesn't have an ARexx port.  As
   written this script will attempt to start the editor Memacs, from the
   Extras disk.

   To function correctly, this script must be renamed EditGen.rexx and copied
   to the REXX: directory.

   This script will attempt to start your editor of choice, and load the
   SOURCE or NOTE file requested by Origins.  Because Origins cannot talk to
   your editor, it will start a new invocation for each file.  After you have
   completed editing and saved a file, quit the editor.  Failure to remember
   this will result in many copies of the editor running simultaneously, and
   using a great deal of memory unnecessarily.

   Memacs does a ScreenToFront() when called.  If your editor doesn't do
   this, you'll have to switch to the Workbench screen to see it.
*/

/* Enable error handling routines */
Signal On Error
Signal On Syntax
Signal On Halt
Signal On IOErr

/* Change this string to the name of your editor */
/* Make sure to include the space after the name */
Editor = 'Memacs '

/* Get the name of the file to edit into this variable */
parse arg Filename

/* Start the editor on this file */
address command 'run 'Editor Filename

Exit

/**********************************************************************/
/*                           Error Handling                           */
/**********************************************************************/

Error:
	Parse Source Type Num MacroName Script Prog Port
	say 'ERROR: Macro "'MacroName'", Error: #'RC' ("'ErrorText(RC)'") on line 'SIGL' **'
	exit

Syntax:
	Parse Source Type Num MacroName Script Prog Port
	say 'SYNTAX: Macro "'MacroName'", Error: #'RC' ("'ErrorText(RC)'") on line 'SIGL' **'
	exit

Halt:
	Parse Source Type Num MacroName Script Prog Port
	say 'HALT: Macro "'MacroName'", Error: #'RC' on line 'SIGL' **'
	exit

IOErr:
	Parse Source Type Num MacroName Script Prog Port
	say 'IOERR: Macro "'MacroName'", Error: #'RC' on line 'SIGL' **'
	exit
